#pragma once

#include "opensbi/opensbi.h"

namespace drivers {
namespace opensbi::legacy {

    [[deprecated("Use the time extension instead")]]
    SbiRet set_timer(uint64_t stime_value);

    [[deprecated("No alternative, git gud git real driver")]]
    SbiRet console_putchar(int ch);

    [[deprecated("No alternative, git gud git real driver")]]
    SbiRet console_getchar();

    [[deprecated("No alternative")]]
    SbiRet clear_ipmi();

    [[deprecated("Use the sPI extension instead")]]
    SbiRet send_ipmi(hart_mask_t hart_mask);

    [[deprecated("Use the RFNC extension instead")]]
    SbiRet remote_fence_i(hart_mask_t hart_mask);

    [[deprecated("Use the RFNC extension instead")]]
    SbiRet remote_sfence_vma(
            hart_mask_t hart_mask,
            sbiword_t start,
            sbiword_t size);

    [[deprecated("Use the RFNC extension instead")]]
    SbiRet remote_sfence_vma_asid(
            hart_mask_t hart_mask,
            sbiword_t start,
            sbiword_t size,
            sbiword_t asid);

    [[deprecated("Use the SRST extension instead")]]
    [[noreturn]] void shutdown();

}  // End namespace opensbi::legacy
}  // End namespace drivers
